﻿Enumeration
  #ca
  #tf
  #op8x16
  #op8x8
  #op8x4
  #cbi
  #chb
EndEnumeration

;menu items
Enumeration
  #file_openpic
  #file_savepic
  #file_font
  #file_quit
EndEnumeration

Global *m=AllocateMemory(6912*2)
Global *f8x16=AllocateMemory(2048)
Global *f8x8=AllocateMemory(2048)
Global *f8x4=AllocateMemory(2048)

CopyMemory(?font8x16,*f8x16,2048)
CopyMemory(?font8x4,*f8x4,2048)
CopyMemory(?font8x8,*f8x8,768)

Global Dim s.l(192)
Global Dim atri.l(255)
Global Dim atrp.l(255)

Procedure drawpic()
  StartDrawing(CanvasOutput(#ca))
  For y=0 To 191
    For x=0 To 31
      v.l=PeekA(*m+s(y)+x)&255;data
      b.l=128                 ;bit weight
      a.l=PeekA(*m+6144+x+y/8*32)&255;attributes
      For i=0 To 7
        If v&b
          Box((x*8+i)*2,y*2,2,2,atri(a))
        Else
          Box((x*8+i)*2,y*2,2,2,atrp(a))
        EndIf
        b>>1
      Next i
    Next x
  Next y
  StopDrawing()
EndProcedure

Procedure dt(x0,y0);,t$)
  t$=GetGadgetText(#tf)
  If t$<>""
    inkc.l=GetGadgetState(#cbi)|(64*GetGadgetState(#chb))
    
    If GetGadgetState(#op8x4)
      ; Debug "not implemented"
      For i=1 To Len(t$)
        ;Debug (i-1)/2
        If i/2+x0=32
          Break
        EndIf
        
        If inkc<>-1
          PokeA(*m+6144+y0*4+x0+(i-1)/2,inkc&255)
          ;Debug y0
        EndIf
        
        ch.l=Asc(Mid(t$,i,1))
        For y=0 To 7
          If y0+y>=192
            Break
          EndIf
          
          If i&1
            PokeA(*m+x0+(i-1)/2+s(y0+y),PeekA(*f8x4+y+ch*8)&$F0 )
          Else
            PokeA(*m+x0+(i-1)/2+s(y0+y),PeekA(*m+x0+(i-1)/2+s(y0+y))|((PeekA(*f8x4+y+ch*8)>>4)&$0F) )
          EndIf
          
        Next y
      Next i
      
    ElseIf GetGadgetState(#op8x8)
      For i=1 To Len(t$)
        If i+x0>=33
          Break
        EndIf
        
        If inkc<>-1
          PokeA(*m+6144+y0*4+x0+i-1,inkc&255)
          ;Debug y0
        EndIf
        
        ch.l=Asc(Mid(t$,i,1))-32
        For y=0 To 7
          If y0+y>=192
            Break
          EndIf
          PokeA ( *m+x0+i-1+s(y0+y),PeekA(*f8x8+y+ch*8) )
        Next y
      Next i
    ElseIf GetGadgetState(#op8x16)
      For i=1 To Len(t$)
        If i+x0>=33
          Break
        EndIf
        If inkc<>-1
          PokeA(*m+6144+y0*4+x0+i-1,inkc&255)
          
          If y0*4+32+x0+i-1<768
            PokeA(*m+6144+y0*4+32+x0+i-1,inkc&255)
          EndIf
        EndIf
        
        ch.l=Asc(Mid(t$,i,1))
        For y=0 To 15
          If y0+y>=192
            Break
          EndIf
          PokeA ( *m+x0+i-1+s(y0+y),PeekA(*f8x16+y+ch*16) )
        Next y
      Next i
      
    EndIf
  EndIf
EndProcedure

Procedure WndProc(hwnd, uMsg, wParam, lParam)
  
  Result = #PB_ProcessPureBasicEvents 
  
  Select uMsg
      
    Case #WM_DRAWITEM 
      *DRAWITEM.DRAWITEMSTRUCT = lParam
      If *DRAWITEM\CtlType = #ODT_COMBOBOX
        id = *DRAWITEM\itemID 
        If id >= 0 And *DRAWITEM\CtlID = #cbi
          InflateRect_(*DRAWITEM\rcItem,-1,-1)
          bru.l=CreateSolidBrush_(atri(id|64))
          FillRect_(*DRAWITEM\hDC,*DRAWITEM\rcItem,bru);brush(id))
          FrameRect_(*DRAWITEM\hDC,*DRAWITEM\rcItem,bru);brush(11))
          DeleteObject_(bru)
        EndIf
      EndIf
      
  EndSelect 
  
  ProcedureReturn Result 
EndProcedure 

Procedure readfnt()
  Pattern$ = "All files (*.*)|*.*"
  File$ = OpenFileRequester("Please choose file to load", "", Pattern$, 0)
  If File$
    *p=0
    tr.l=0
    If GetGadgetState(#op8x4)
      *p=*f8x4
      tr=2048
    ElseIf GetGadgetState(#op8x8)
      *p=*f8x8
      tr=768
    ElseIf GetGadgetState(#op8x16)
      *p=*f8x16
      tr=2048
    EndIf
    If *p
      If ReadFile(0,File$)
        If ReadData(0,*p,tr)
          CloseFile(0)
        Else
          MessageRequester("Error","Can't read"+ Chr(10) + File$)
        EndIf;If ReadFile(0,File$)
      Else
        MessageRequester("Error","Can't open"+ Chr(10) + File$)
      EndIf;ReadFile(0,File$)
      
    EndIf
  EndIf
EndProcedure 

Procedure openscr()
  StandardFile$ = ""   ; set initial file+path to display
  Pattern$ = "ZX screen (*.scr)|*.scr"
  File$ = OpenFileRequester("Please choose file to load", StandardFile$, Pattern$, 0)
  If File$
    If FileSize(File$)=6912
      If ReadFile(0,File$)
        If ReadData(0,*m,6912)
          CopyMemory(*m,*m+6912,6912)
          drawpic()
          CloseFile(0)
        Else
          MessageRequester("Error","Can't read"+ Chr(10) + File$)
        EndIf;ReadData(0,*m,6912)
      Else
        MessageRequester("Error","Can't open"+ Chr(10) + File$)
      EndIf;ReadFile(0,File$)
    EndIf  ;FileSize(File$)=6912
    
  EndIf;File$
EndProcedure

Procedure savescr()
  StandardFile$ = ""   ; set initial file+path to display
  Pattern$ = "ZX screen (*.scr)|*.scr"
  File$ = SaveFileRequester("Please choose file to save", StandardFile$, Pattern$, 0)
  If File$
    ;    Debug LCase(Mid(File$,Len(File$)-4,4))
    If LCase(Mid(File$,Len(File$)-4,4))<>".scr"
      File$=File$+".scr"
    EndIf
    
    If CreateFile(0,File$)
      If WriteData(0,*m,6912)
        CloseFile(0)
      Else
        MessageRequester("Error","Can't write"+ Chr(10) + File$)
      EndIf
    Else
      MessageRequester("Error","Can't create"+ Chr(10) + File$)
    EndIf
  EndIf
  
  
EndProcedure

;calc adresses
p=0
For k=0 To 2;2048
  For j=0 To 7;0..31,32..63
    For i=0 To 7;$4000..$4700
      hl=i*256+j*32+k*2048
      s(p)=hl
      p+1
    Next i
  Next j
Next k

;calc attributes
For i=0 To 255
  If i&64
    bri=255
  Else
    bri=127
  EndIf
  
  re=0
  gr=0
  bl=0
  
  If i&1:bl=bri:EndIf
  If i&2:re=bri:EndIf
  If i&4:gr=bri:EndIf
  atri(i)=RGB(re,gr,bl)
  
  re=0
  gr=0
  bl=0
  
  If i&8:bl=bri:EndIf
  If i&16:re=bri:EndIf
  If i&32:gr=bri:EndIf
  atrp(i)=RGB(re,gr,bl)
  
Next i

CopyMemory(?zxpic,*m,6912)
CopyMemory(*m,*m+6912,6912)

If OpenWindow(0, 0, 0, 640, 480, "ZX text 0.2 by g0blinish", #PB_Window_SystemMenu | #PB_Window_ScreenCentered|#PB_Window_MinimizeGadget)
  CanvasGadget(#ca, 0, 0, 256*2, 192*2);:GadgetToolTip(#ca,"screen for draw text")
  OptionGadget(#op8x4, 514, 0, 40, 20, "8x4"):GadgetToolTip(#op8x4,"Font type")
  OptionGadget(#op8x8, 514, 20, 40, 20, "8x8")
  OptionGadget(#op8x16, 514, 40, 40, 20, "8x16")
  SetGadgetState(#op8x4,1)
  StringGadget(#tf,0,390,512,20,"hujcy",#ES_CENTER):GadgetToolTip(#tf,"Type text here")
  
  SetWindowCallback(@WndProc())  
  ComboBoxGadget(#cbi,514,60,40,24,#CBS_OWNERDRAWFIXED):GadgetToolTip(#cbi, "INK color or transparent")
  For x = 0 To 7
    AddGadgetItem(#cbi,-1, "")
  Next
  SendMessage_(GadgetID(#cbi),#CB_SETITEMHEIGHT,0,24)
  CheckBoxGadget(#chb,554,60,40,20,"B"):GadgetToolTip(#chb, "Bright for INK")
  If CreateMenu(0, WindowID(0))    ; menu creation starts....
    MenuTitle("File")
    MenuItem(#file_openpic, "Open pic.."   +Chr(9)+"Ctrl+O")
    MenuItem(#file_savepic, "Save pic.."   +Chr(9)+"Ctrl+S")
    MenuItem(#file_font, "Open Font..")
    MenuItem(#file_quit, "Quit"  +Chr(9)+"Ctrl+Q")
    
    AddKeyboardShortcut(0, #PB_Shortcut_Control | #PB_Shortcut_O,#file_openpic)
    AddKeyboardShortcut(0, #PB_Shortcut_Control | #PB_Shortcut_S,#file_savepic)
    AddKeyboardShortcut(0, #PB_Shortcut_Control | #PB_Shortcut_Q,#file_quit)
  EndIf
  
  ;dt(0,0,"hujpizdaSkovoroda")
  drawpic()
  
  Repeat
    Event = WaitWindowEvent()
    If GetAsyncKeyState_(#VK_ESCAPE)=-32767
      Break
    EndIf
    Select Event
      Case #PB_Event_Menu
        Select EventMenu()
          Case #file_font
            readfnt()
          Case #file_savepic
            savescr()
          Case #file_openpic
            openscr()
          Case #file_quit 
            Break
        EndSelect
      Case #PB_Event_Gadget
        Select EventGadget()
          Case #ca
            x0.l = Int(GetGadgetAttribute(#ca, #PB_Canvas_MouseX)/16)
            y0.l = Int(GetGadgetAttribute(#ca, #PB_Canvas_MouseY)/16)*8
            If EventType() = #PB_EventType_MouseMove
              CopyMemory(*m,*m+6912,6912)
              dt(x0,y0)
              drawpic()
              CopyMemory(*m+6912,*m,6912)
            ElseIf  EventType() = #PB_EventType_LeftButtonDown
              dt(x0,y0)
              CopyMemory(*m,*m+6912,6912)
              drawpic()
            EndIf
            
        EndSelect
    EndSelect
    
  Until Event = #PB_Event_CloseWindow
EndIf


FreeMemory(*m)
FreeMemory(*f8x16)
FreeMemory(*f8x8)
FreeMemory(*f8x4)

DataSection
  zxpic:
  IncludeBinary "EyeAche-CBS-daemon.scr"
  font8x8:
  IncludeBinary "zx48.bin"
  font8x4:
  IncludeBinary "8x4.bin"
  font8x16:
  IncludeBinary "BY_HAND.FNT"

; IDE Options = PureBasic 5.30 (Windows - x86)
; CursorPosition = 273
; FirstLine = 242
; Folding = --
; EnableUnicode
; EnableXP
; UseIcon = textdoc.ico
; Executable = zt.exe